︠eb1c564e-8094-414b-89c1-1df0792fcc1ci︠
%html
<h1><center>ASCII Pad Functions</center></h1>
︡7d40e939-8071-4d3a-8563-f169e8e30e1a︡{"done":true,"html":"<h1><center>ASCII Pad Functions</center></h1>"}
︠560b7666-3483-40e5-b2c0-4d4f475d34bai︠

%md
<b>Description.</b> This is a procedure for converting ordinary text (plaintext) to padded ASCII number. It takes as input a sentence written between " and ", it pads each character one after another, and returns the padded characters as a list. It 'pads' by adding 100 to each list item.
︡f1306598-b628-4b4a-8f01-2f5f9d1b7b81︡{"done":true,"md":"<b>Description.</b> This is a procedure for converting ordinary text (plaintext) to padded ASCII number. It takes as input a sentence written between \" and \", it pads each character one after another, and returns the padded characters as a list. It 'pads' by adding 100 to each list item."}
︠58cc0ab2-10a8-4202-8f0f-b04bd4968850s︠
########################################################################################
# The ASCIIPad takes a string (plaintext) as an input and gives a number as an output. #
# The number is represented in a ASCII like format that is padded.                     #
########################################################################################


def ASCIIPad(Message):
    newList = []
    messLen = len(Message)
    tempIter = messLen - 1
    while tempIter >= 0:
        newList.append(Message[tempIter])
        tempIter -= 1
    x = [100+ord(newList[i]) for i in range(messLen)];
    x = ZZ(x,1000);
    return(x);

#################################################################################################
# The input is a number and the output is the original message. If the input is not padded ASCII#
# version of a message it returns the value: "This is not a padded ASCII string"                #
#################################################################################################
def ASCIIDepad(Number):
    n = Number.ndigits() % 3;
    if (n > 0):
        print("This is not a padded ASCII string\n");
    else:
        L = [((Number - (Number % (1000^i)))/1000^i)%1000 - 100 for i in range(Number.ndigits()/3)];
        N = "";
        for i in range(Number.ndigits()/3):
            N = chr(L[i]) + N;
        return(N)
︡03b554ac-60ff-47f1-9436-f72115afe0ca︡{"done":true}
︠5ace5ce8-47df-4b92-86f2-55e296400b13i︠
%md
<b>Example.</b> Convert the plaintext "Bob, your public key is not secure!"  into an ASCII number. Then depad the resulting number.
︡429b637e-9db7-4d9a-9fdc-1f9528bd4750︡{"done":true,"md":"<b>Example.</b> Convert the plaintext \"Bob, your public key is not secure!\"  into an ASCII number. Then depad the resulting number."}
︠845f992c-0ac1-4a73-a320-6e37ed072373s︠


M = "Bob, your  public  key is not secure!";
Padded = ASCIIPad(M);
print ("The padded ASCII version of the plaitext: Bob, your public key is not secure! is" , Padded,  "\n")
print ("The function ASCIIDepad returns the original plaintext" , ASCIIDepad(Padded))
︡faab2696-b31e-4723-8790-6ba49ebe99ef︡{"stdout":"The padded ASCII version of the plaitext: Bob, your public key is not secure! is 166211198144132221211217214132132212217198208205199132132207201221132205215132210211216132215201199217214201133 \n\n"}︡{"stdout":"The function ASCIIDepad returns the original plaintext Bob, your  public  key is not secure!\n"}︡{"done":true}
︠51395f09-4831-4a4f-a897-ee084bd5e318i︠
%md
The function <b>isASCIIPadded</b> returns a true false value on whether a given number represents a plaintext.

︡aee25eae-5b8f-4513-9200-110d3ba8d02c︡{"done":true,"md":"The function <b>isASCIIPadded</b> returns a true false value on whether a given number represents a plaintext."}
︠eaf8748c-7411-490f-ab61-3c728e58f71fs︠
def isASCIIPadded(Number):
    N = ""
    n = Number.ndigits() % 3;
    if (n > 0):
        return False;
    L = [((Number - (Number % (1000^i)))/1000^i)%1000 - 100 for i in range(Number.ndigits()/3)];
    for i in range(Number.ndigits()/3):
        if L[i] < 0:
            return False
        if L[i] > 255:
            return False
    return True
︡e841726f-f5cf-4943-b441-7be75b362435︡{"done":true}
︠474ea346-a1a2-4d43-8491-dc8fb2cf4a2bi︠
%md
<b>Example.</b> The function isASCIIPadded is applied to the number 177201215215197203201. It returns "true" value. Next, function is ASCIIPadded is applied to the number 177201215215197203701. It returns "false" value.
︡cdc1f353-614f-4745-b507-e889e4e9a51b︡{"done":true,"md":"<b>Example.</b> The function isASCIIPadded is applied to the number 177201215215197203201. It returns \"true\" value. Next, function isASCIIPadded is applied to the number 177201215215197203701. It returns \"false\" value."}
︠3182de9e-a8ea-43e0-8649-dab8988e0ef7s︠
M = ASCIIPad("Plaintext")
M
isASCIIPadded(M)
P=489357392874032984032984011
P
isASCIIPadded(P)
︡6f556fbb-165e-4b63-967a-674ea166d50e︡{"stdout":"Plaintext\nP\n"}︡{"stdout":"180208197205210216201220216\n"}︡{"stdout":"True\n"}︡{"stdout":"489357392874032984032984011\n"}︡{"stdout":"False\n"}︡{"done":true}
︠701abb6b-a4b5-452b-b360-88bc100f8d00︠









